package dev.shadowsoffire.apotheosis.ench.table;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.ench.table.ApothEnchantmentMenu;
import it.unimi.dsi.fastutil.floats.Float2FloatMap;
import it.unimi.dsi.fastutil.floats.Float2FloatOpenHashMap;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import net.minecraft.world.item.enchantment.Enchantment;

public class Builder {
  private final Float2FloatMap eternaMap = (Float2FloatMap)new Float2FloatOpenHashMap();
  
  private final Set<Enchantment> blacklist = new HashSet<>();
  
  private boolean allowsTreasure = false;
  
  private final float[] stats = new float[5];
  
  public Builder(int itemEnch) {
    addQuanta(15.0F);
    addArcana(itemEnch / 2.0F);
    addClues(1);
  }
  
  public void addEterna(float eterna, float max) {
    this.eternaMap.put(max, this.eternaMap.getOrDefault(max, 0.0F) + eterna);
  }
  
  public void addQuanta(float quanta) {
    this.stats[1] = this.stats[1] + quanta;
  }
  
  public void addArcana(float arcana) {
    this.stats[2] = this.stats[2] + arcana;
  }
  
  public void addRectification(float rectification) {
    this.stats[3] = this.stats[3] + rectification;
  }
  
  public void addClues(int clues) {
    this.stats[4] = this.stats[4] + clues;
  }
  
  public void blacklistEnchant(Enchantment ench) {
    this.blacklist.add(ench);
  }
  
  public void setAllowsTreasure(boolean allowsTreasure) {
    this.allowsTreasure = allowsTreasure;
  }
  
  public ApothEnchantmentMenu.TableStats build() {
    List<Float2FloatMap.Entry> entries = new ArrayList<>((Collection<? extends Float2FloatMap.Entry>)this.eternaMap.float2FloatEntrySet());
    Collections.sort(entries, Comparator.comparing(Float2FloatMap.Entry::getFloatKey));
    for (Float2FloatMap.Entry e : entries) {
      if (e.getFloatKey() > 0.0F) {
        this.stats[0] = Math.min(e.getFloatKey(), this.stats[0] + e.getFloatValue());
        continue;
      } 
      this.stats[0] = this.stats[0] + e.getFloatValue();
    } 
    return new ApothEnchantmentMenu.TableStats(this.stats, this.blacklist, this.allowsTreasure);
  }
}
